//
//  TSFileManagerTool.swift
//  TSLiveWallpaper
//
//  Created by 100Years on 2024/12/26.
//

class TSFileManagerTool {
    
    
    
    static func copyFileWithOverwrite(from sourceURL: URL, to targetURL: URL) {
        let fileManager = FileManager.default
        do {
            removeItem(from: targetURL)
            try fileManager.copyItem(at: sourceURL, to: targetURL)
            debugPrint("文件复制成功！")
        } catch {
            debugPrint("文件复制失败: \(error.localizedDescription)")
        }
    }
    
    static func removeItem(from sourceURL: URL) {
        let fileManager = FileManager.default
        do {
            // 如果目标路径存在同名文件，先删除旧文件
            if fileManager.fileExists(atPath: sourceURL.path) {
                try fileManager.removeItem(at: sourceURL)
            }
            debugPrint("文件删除成功！")
        } catch {
            debugPrint("文件删除失败: \(error.localizedDescription)")
        }
    }
}
